// Generated by CoffeeScript 1.7.1
(function() {
  var actions, cli, commander, config, deploy, pkg, util, _;

  commander = require('commander');

  _ = require('underscore');

  pkg = require('../package');

  deploy = require('./deploy');

  config = require('./config');

  util = require('./util');

  actions = {
    deploy: function() {
      var options, _options;
      options = _.last(arguments);
      _options = {
        projects: _.first(arguments, arguments.length - 1),
        config: options.config || null
      };
      return deploy(_options);
    },
    config: function() {
      var action, options, _options;
      options = _.last(arguments);
      action = _.first(arguments);
      action = typeof action === 'string' ? action : null;
      _options = {
        action: action,
        configFile: options.config
      };
      return config(_options);
    }
  };

  cli = function() {
    commander.version(pkg.version).usage('<command> [options] [projects]');
    commander.command('deploy').description('deploy local projects to servers').option('-c, --config <config>', 'user defined configure file').usage('[options] [projects]').action(actions.deploy);
    commander.command('d').description('(alias) of deploy').option('-c, --config <config>', 'user defined configure file').usage('[options] [projects]').action(actions.deploy);
    commander.command('config').description('add or update your configure file').option('-c, --config <config>', 'user defined configure file').usage('show|add|edit').action(actions.config);
    commander.command('c').description('(alias) of config').option('-c, --config <config>', 'user defined configure file').usage('show|add|edit').action(actions.config);
    commander.parse(process.argv);
    if (process.argv.length < 3) {
      return commander.help();
    }
  };

  module.exports = cli;

}).call(this);
