// Generated by CoffeeScript 1.7.1
(function() {
  var async, exec, fs, logger, path, projectPrefix, util, _;

  fs = require('fs');

  path = require('path');

  async = require('async');

  _ = require('underscore');

  logger = require('graceful-logger');

  exec = require('child_process').exec;

  projectPrefix = 'project:';

  util = {
    sep1: '=================================================================',
    sep2: '-----------------------------------------------------------------',
    execCmd: function(cmd, callback) {
      var child;
      if (callback == null) {
        callback = function() {};
      }
      logger.info("run command: " + cmd);
      child = exec(cmd, callback);
      child.stdout.on('data', function(data) {
        return process.stdout.write(data);
      });
      return child.stderr.on('data', function(data) {
        return process.stderr.write(data);
      });
    },
    expandPath: function(filePath) {
      var matches;
      if (matches = filePath.match(/^~(.*)/)) {
        return "" + process.env.HOME + matches[1];
      } else {
        return filePath;
      }
    },
    getConfigPath: function(file) {
      var configPath, filePaths, i;
      configPath = file;
      if (configPath == null) {
        filePaths = [path.resolve('./.sneakyrc.json'), path.resolve('./.sneakyrc.js'), path.resolve('./.sneakyrc'), util.expandPath('~/.sneakyrc.json'), util.expandPath('~/.sneakyrc.js'), util.expandPath('~/.sneakyrc')];
        for (i in filePaths) {
          file = filePaths[i];
          if (fs.existsSync(file)) {
            configPath = file;
            break;
          }
        }
        configPath || (configPath = util.expandPath('~/.sneakyrc.json'));
      }
      return configPath;
    },
    loadConfig: function(file, callback) {
      var args;
      if (callback == null) {
        callback = function() {};
      }
      args = arguments;
      return async.waterfall([
        function(next) {
          var configPath, configs, e;
          configPath = util.getConfigPath(file);
          try {
            configs = JSON.parse(fs.readFileSync(configPath));
          } catch (_error) {
            e = _error;
            configs = {};
          }
          return next(null, configs);
        }, function(configs, next) {
          var config, k;
          for (k in configs) {
            config = configs[k];
            config.name || (config.name = path.basename(process.cwd()) + ("-" + k));
          }
          return next(null, configs);
        }
      ], callback);
    },
    saveConfig: function(file, configs, callback) {
      var configPath;
      if (callback == null) {
        callback = function() {};
      }
      configPath = util.getConfigPath(file);
      return fs.writeFile(configPath, JSON.stringify(configs, null, 2), callback);
    }
  };

  module.exports = util;

}).call(this);
